pipeline {
    agent any
    stages {
        stage('git checkout') {
            steps {
                git 'https://gitlab.com/balpreet.singh1/wireguard-terraform.git'
            }
        }
       stage('terraform init') {
            steps {
                sh 'terraform init'
                sh 'terraform plan'
            }
        }
        stage('terraform validate') {
            steps {
                sh 'terraform validate'
            }
        }
        stage('Approval') {
           steps {
             script {
          def userInput = input(id: 'confirm', message: 'Apply Terraform?', parameters: [ [$class: 'BooleanParameterDefinition', defaultValue: false, description: 'Apply terraform', name: 'confirm'] ])
                }
            }
        }
        stage('terraform apply') {
            steps {
                sh 'terraform apply --auto-approve'
            }
        }
        

        stage('Install Boto') {
            steps {
                git 'https://github.com/boto/boto3.git'
                sh 'pip install --user .'  
            }
        }


        stage('git checkout wireguard role') {
            steps {
                git 'https://gitlab.com/balpreet.singh1/wireguard-ansible.git'
            }
        }   
        
        stage('Setup Wireguard') {
            steps {
ansiblePlaybook credentialsId: 'ANSIBLE', installation: 'ansible', inventory: 'aws_ec2.yml', playbook: 'wireguard.yml'            
            }
        } 
        stage('git checkout node exporter role') {
            steps {
                git 'https://gitlab.com/balpreet.singh1/node-exporter-wg.git'
            }
        }   
        
        stage('Setup node exporter') {
            steps {
ansiblePlaybook credentialsId: 'ANSIBLE', installation: 'ansible', inventory: 'aws_ec2.yml', playbook: 'wireguard.yml'            
            }
        }   
        stage('git checkout prometheus role') {
            steps {
                git 'https://gitlab.com/balpreet.singh1/prometheus-wg.git'
            }
        }   
        
        stage('Setup Prometheus') {
            steps {
ansiblePlaybook credentialsId: 'ANSIBLE', installation: 'ansible', inventory: 'aws_ec2.yml', playbook: 'wireguard.yml'            
            }
        }           
    }
}
